#! /usr/bin/perl
use strict;
use warnings;
use Parallel::Prefork;

my $pm = Parallel::Prefork->new(
    +{
        max_workers  => 5,
        trap_signals => +{
            TERM => 'TERM',
            HUP  => 'TERM',
            USR1 => undef,
        },
    }
);
my $max_requests_per_child = 50;
while ( $pm->signal_received ne 'TERM' ) {
    $pm->start and next;
    my $i=0;
    while ( $i++ < $max_requests_per_child ) {
        # ここでワーカの処理を起動させる
    }
    $pm->finish;
}
$pm->wait_all_children;
